Ext.ux.grid.FiltersFeature
Hierarchy
Ext.BaseExt.util.ObservableExt.grid.feature.FeatureExt.ux.grid.FiltersFeatureUses
Files
FiltersFeature is a grid feature that allows for a slightly more robust representation of filtering than what is provided by the default store.
Filtering is adjusted by the user using the grid's column header menu (this menu can be disabled through configuration). Through this menu users can configure, enable, and disable filters for each column.
Features
Filtering implementations:
Default filtering for Strings, Numeric Ranges, Date Ranges, Lists (which can be backed by a Ext.data.Store), and Boolean. Additional custom filter types and menus are easily created by extending Ext.ux.grid.filter.Filter.
Graphical Indicators:
Columns that are filtered have a configurable css class applied to the column headers.
Automatic Reconfiguration:
Filters automatically reconfigure when the grid 'reconfigure' event fires.
Stateful:
Filter information will be persisted across page loads by specifying a stateId
in the Grid configuration.
The filter collection binds to the beforestaterestore and beforestatesave events in order to be stateful.
GridPanel Changes:
- A
filtersproperty is added to the GridPanel using this feature. - A
filterupdateevent is added to the GridPanel and is fired upon onStateChange completion.
Server side code examples:
- PHP - (Thanks VinylFox)
- Ruby on Rails - (Thanks Zyclops)
- Ruby on Rails - (Thanks Rotomaul)
Example usage:
var store = Ext.create('Ext.data.Store', {
pageSize: 15
...
});
var filtersCfg = {
ftype: 'filters',
autoReload: false, //don't reload automatically
local: true, //only filter locally
// filters may be configured through the plugin,
// or in the column definition within the headers configuration
filters: [{
type: 'numeric',
dataIndex: 'id'
}, {
type: 'string',
dataIndex: 'name'
}, {
type: 'numeric',
dataIndex: 'price'
}, {
type: 'date',
dataIndex: 'dateAdded'
}, {
type: 'list',
dataIndex: 'size',
options: ['extra small', 'small', 'medium', 'large', 'extra large'],
phpMode: true
}, {
type: 'boolean',
dataIndex: 'visible'
}]
};
var grid = Ext.create('Ext.grid.Panel', {
store: store,
columns: ...,
features: [filtersCfg],
height: 400,
width: 700,
bbar: Ext.create('Ext.PagingToolbar', {
store: store
})
});
// a filters property is added to the GridPanel
grid.filters
Available since: 4.0.7
Config options
Defaults to true, reloading the datasource when a filter change happens.
Set this to false to prevent the datastore from being reloaded if there
are changes to the filters. See updateBuffer.
Defaults to: true
Available since: 4.0.7
Specify true for buildQuery to use Ext.util.JSON.encode to encode the filter query parameter sent with a remote request. Defaults to false.
Available since: 4.0.7
The css class to be applied to column headers with active filters. Defaults to 'ux-filterd-column'.
Defaults to: 'ux-filtered-column'
Available since: 4.0.7
An Array of filters config objects. Refer to each filter type class for configuration details specific to each filter type. Filters for Strings, Numeric Ranges, Date Ranges, Lists, and Boolean are the standard filters available.
Available since: 4.0.7
A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.
DOM events from Ext JS Components
While some Ext JS Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually
only done when extra value can be added. For example the DataView's itemclick event passing the node clicked on. To access DOM events directly from a
child element of a Component, we need to specify the element option to identify the Component property to add a
DOM listener to:
new Ext.panel.Panel({
width: 400,
height: 200,
dockedItems: [{
xtype: 'toolbar'
}],
listeners: {
click: {
element: 'el', //bind to the underlying el property on the panel
fn: function(){ console.log('click el'); }
},
dblclick: {
element: 'body', //bind to the underlying body property on the panel
fn: function(){ console.log('dblclick body'); }
}
}
});
Available since: 1.1.0
true to use Ext.data.Store filter functions (local filtering) instead of the default (false) server side filtering.
Defaults to: false
Available since: 4.0.7
The url parameter prefix for the filters. Defaults to 'filter'.
Defaults to: 'filter'
Available since: 4.0.7
Defaults to true, including a filter submenu in the default header menu.
Defaults to: true
Available since: 4.0.7
Name of the value to be used to store state information.
Name of the value to be used to store state information.
Available since: 4.0.7
Properties
Instance Properties Most features will not modify the data returned to the view. ...Most features will not modify the data returned to the view.
This is limited to one feature that manipulates the data per grid view.
Defaults to: false
Available since: 4.0.0
True when feature is disabled. ...True when feature is disabled.
Defaults to: false
Available since: 4.0.0
Prefix to use when firing events on the view. ...Prefix to use when firing events on the view.
For example a prefix of group would expose "groupclick", "groupcontextmenu", "groupdblclick".
Available since: 4.0.0
Overrides: Ext.grid.feature.Grouping.eventPrefix
Selector used to determine when to fire the event with the eventPrefix.
Selector used to determine when to fire the event with the eventPrefix.
Available since: 4.0.0
Overrides: Ext.grid.feature.Grouping.eventSelector
eventsSuspended : NumberprivateInitial suspended call count. ...Initial suspended call count. Incremented when suspendEvents is called, decremented when resumeEvents is called.
Defaults to: 0
Available since: 4.1.1
doesn't handle grid body events
Most features will expose additional events, some may not and will
need to change th...doesn't handle grid body events
Most features will expose additional events, some may not and will
need to change this to false.
Defaults to: false
Available since: 4.0.7
Overrides: Ext.grid.feature.Feature.hasFeatureEvent
hasListeners : ObjectreadonlyThis object holds a key for any event that has a listener. ...This object holds a key for any event that has a listener. The listener may be set
directly on the instance, or on its class or a super class (via observe) or
on the MVC EventBus. The values of this object are truthy
(a non-zero number) and falsy (0 or undefined). They do not represent an exact count
of listeners. The value for an event is truthy if the event must be fired and is
falsy if there is no need to fire the event.
The intended use of this property is to avoid the expense of fireEvent calls when
there are no listeners. This can be particularly helpful when one would otherwise
have to call fireEvent hundreds or thousands of times. It is used like this:
if (this.hasListeners.foo) {
this.fireEvent('foo', this, arg1);
}
Available since: 4.1.0
true in this class to identify an object as an instantiated Feature, or subclass thereof. ...true in this class to identify an object as an instantiated Feature, or subclass thereof.
Defaults to: true
Available since: 4.0.0
true in this class to identify an object as an instantiated Observable, or subclass thereof. ...true in this class to identify an object as an instantiated Observable, or subclass thereof.
Defaults to: true
Available since: 4.0.0
Get the reference to the current class from which this object was instantiated. ...Get the reference to the current class from which this object was instantiated. Unlike statics,
this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics
for a detailed comparison
Ext.define('My.Cat', {
statics: {
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
alert(this.self.speciesName); // dependent on 'this'
},
clone: function() {
return new this.self();
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
}
});
var cat = new My.Cat(); // alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
Available since: 4.0.0
Most features will not modify the data returned to the view. This is limited to one feature that manipulates the data per grid view.
Defaults to: false
Available since: 4.0.0
True when feature is disabled.
Defaults to: false
Available since: 4.0.0
Prefix to use when firing events on the view. For example a prefix of group would expose "groupclick", "groupcontextmenu", "groupdblclick".
Available since: 4.0.0
Overrides: Ext.grid.feature.Grouping.eventPrefix
Selector used to determine when to fire the event with the eventPrefix.
Selector used to determine when to fire the event with the eventPrefix.
Available since: 4.0.0
Overrides: Ext.grid.feature.Grouping.eventSelector
Initial suspended call count. Incremented when suspendEvents is called, decremented when resumeEvents is called.
Defaults to: 0
Available since: 4.1.1
doesn't handle grid body events
Most features will expose additional events, some may not and will need to change this to false.
Defaults to: false
Available since: 4.0.7
Overrides: Ext.grid.feature.Feature.hasFeatureEvent
This object holds a key for any event that has a listener. The listener may be set directly on the instance, or on its class or a super class (via observe) or on the MVC EventBus. The values of this object are truthy (a non-zero number) and falsy (0 or undefined). They do not represent an exact count of listeners. The value for an event is truthy if the event must be fired and is falsy if there is no need to fire the event.
The intended use of this property is to avoid the expense of fireEvent calls when there are no listeners. This can be particularly helpful when one would otherwise have to call fireEvent hundreds or thousands of times. It is used like this:
if (this.hasListeners.foo) {
this.fireEvent('foo', this, arg1);
}
Available since: 4.1.0
true in this class to identify an object as an instantiated Feature, or subclass thereof.
Defaults to: true
Available since: 4.0.0
true in this class to identify an object as an instantiated Observable, or subclass thereof.
Defaults to: true
Available since: 4.0.0
Get the reference to the current class from which this object was instantiated. Unlike statics,
this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics
for a detailed comparison
Ext.define('My.Cat', {
statics: {
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
alert(this.self.speciesName); // dependent on 'this'
},
clone: function() {
return new this.self();
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
}
});
var cat = new My.Cat(); // alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
Available since: 4.0.0
Static Properties
Methods
Instance Methods ...
Available since: 4.0.7
Parameters
- config : Object
Returns
Overrides: Ext.grid.feature.Feature.constructor
addEvents( eventNames )Adds the specified events to the list of events which this Observable may fire. ...Adds the specified events to the list of events which this Observable may fire.
Available since: 1.1.0
Parameters
Adds a filter to the collection and observes it for state change. ...Adds a filter to the collection and observes it for state change.
Available since: 4.0.7
Parameters
- config : Object/Ext.ux.grid.filter.Filter
A filter configuration or a filter object.
Returns
- Ext.ux.grid.filter.Filter
The existing or newly created filter object.
addFilters( filters )Adds filters to the collection. ...Adds filters to the collection.
Available since: 4.0.7
Parameters
- filters : Array
An Array of filter configuration objects.
Appends an event handler to this object. ...Appends an event handler to this object. For example:
myGridPanel.on("mouseover", this.onMouseOver, this);
The method also allows for a single argument to be passed which is a config object
containing properties which specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
Names of methods in a specified scope may also be used. Note that
scope MUST be specified to use this option:
myGridPanel.on({
cellClick: {fn: 'onCellClick', scope: this, single: true},
mouseover: {fn: 'onMouseOver', scope: panel}
});
Available since: 1.1.0
Parameters
- eventName : String/Object
The name of the event to listen for.
May also be an object who's property names are event names.
- fn : Function (optional)
The method the event invokes, or if scope is specified, the name* of the method within
the specified scope. Will be called with arguments
given to fireEvent plus the options parameter described below.
- scope : Object (optional)
The scope (this reference) in which the handler function is
executed. If omitted, defaults to the object which fired the event.
- options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last
argument to every event handler.
This object may contain any of the following properties:
- scope : Object
The scope (this reference) in which the handler function is executed. If omitted,
defaults to the object which fired the event.
- delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
- single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
- buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed
by the specified number of milliseconds. If the event fires again within that time,
the original handler is not invoked, but the new handler is scheduled in its place.
- target : Ext.util.Observable
Only call the handler if the event was fired on the target Observable, not if the event
was bubbled up from a child Observable.
- element : String
This option is only valid for listeners bound to Components.
The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of
Components which will exist only after the Component is rendered.
For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({
title: 'The title',
listeners: {
click: this.handlePanelClick,
element: 'body'
}
});
- destroyable : Boolean (optional)
When specified as true, the function returns A Destroyable object. An object which implements the destroy method which removes all listeners added in this call.
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, {
single: true,
delay: 100
});
Defaults to: false
Returns
- Object
Only when the destroyable option is specified.
A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:
this.btnListeners = = myButton.on({
destroyable: true
mouseover: function() { console.log('mouseover'); },
mouseout: function() { console.log('mouseout'); },
click: function() { console.log('click'); }
});
And when those listeners need to be removed:
Ext.destroy(this.btnListeners);
or
this.btnListeners.destroy();
Overrides: Ext.AbstractComponent.addListener
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destr...Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destroyed.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
- options : Object (optional)
If the ename parameter was an event name, this is the
addListener options.
Returns
- Object
Only when the destroyable option is specified.
A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:
this.btnListeners = = myButton.mon({
destroyable: true
mouseover: function() { console.log('mouseover'); },
mouseout: function() { console.log('mouseout'); },
click: function() { console.log('click'); }
});
And when those listeners need to be removed:
Ext.destroy(this.btnListeners);
or
this.btnListeners.destroy();
applyState( grid, state )privateHandler for the grid's beforestaterestore event (fires before the state of the
grid is restored). ... attachEvents( )templateApproriate place to attach events to the view, selectionmodel, headerCt, etc ...Approriate place to attach events to the view, selectionmodel, headerCt, etc
Available since: 4.0.7
This is a template method.
a hook into the functionality of this class.
Feel free to override it in child classes.
Overrides: Ext.grid.feature.Feature.attachEvents
bindStore( store )Changes the data store bound to this view and refreshes it. ...Changes the data store bound to this view and refreshes it.
Available since: 4.0.7
Parameters
- store : Ext.data.Store
The store to bind to this view
Function to take the active filters data and build it into a query. ...Function to take the active filters data and build it into a query.
The format of the query depends on the encode configuration:
false (Default) :
Flatten into query string of the form (assuming paramPrefix='filters':
filters[0][field]="someDataIndex"&
filters[0][data][comparison]="someValue1"&
filters[0][data][type]="someValue2"&
filters[0][data][value]="someValue3"&
true :
JSON encode the filter data
{filters:[{"field":"someDataIndex","comparison":"someValue1","type":"someValue2","value":"someValue3"}]}
Override this method to customize the format of the filter query for remote requests.
Available since: 4.0.7
Parameters
- filters : Array
A collection of objects representing active filters and their configuration.
Each element will take the form of {field: dataIndex, data: filterConf}. dataIndex is not assured
to be unique as any one filter may be a composite of more basic filters for the same dataIndex.
Returns
- Object
Query keys and values
Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: functi...Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
this.callOverridden();
alert("Meeeeoooowwww");
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
This method has been deprecated
as of 4.1. Use callParent instead.
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callOverridden(arguments)
Returns
- Object
Returns the result of calling the overridden method
Call the "parent" method of the current method. ...Call the "parent" method of the current method. That is the method previously
overridden by derivation or by an override (see Ext.define).
Ext.define('My.Base', {
constructor: function (x) {
this.x = x;
},
statics: {
method: function (x) {
return x;
}
}
});
Ext.define('My.Derived', {
extend: 'My.Base',
constructor: function () {
this.callParent([21]);
}
});
var obj = new My.Derived();
alert(obj.x); // alerts 21
This can be used with an override as follows:
Ext.define('My.DerivedOverride', {
override: 'My.Derived',
constructor: function (x) {
this.callParent([x*2]); // calls original My.Derived constructor
}
});
var obj = new My.Derived();
alert(obj.x); // now alerts 42
This also works with static methods.
Ext.define('My.Derived2', {
extend: 'My.Base',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Base.method
}
}
});
alert(My.Base.method(10); // alerts 10
alert(My.Derived2.method(10); // alerts 20
Lastly, it also works with overridden static methods.
Ext.define('My.Derived2Override', {
override: 'My.Derived2',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Derived2.method
}
}
});
alert(My.Derived2.method(10); // now alerts 40
To override a method and replace it and also call the superclass method, use
callSuper. This is often done to patch a method to fix a bug.
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callParent(arguments)
Returns
- Object
Returns the result of calling the parent method
This method is used by an override to call the superclass method but bypass any
overridden method. ...This method is used by an override to call the superclass method but bypass any
overridden method. This is often done to "patch" a method that contains a bug
but for whatever reason cannot be fixed directly.
Consider:
Ext.define('Ext.some.Class', {
method: function () {
console.log('Good');
}
});
Ext.define('Ext.some.DerivedClass', {
method: function () {
console.log('Bad');
// ... logic but with a bug ...
this.callParent();
}
});
To patch the bug in DerivedClass.method, the typical solution is to create an
override:
Ext.define('App.paches.DerivedClass', {
override: 'Ext.some.DerivedClass',
method: function () {
console.log('Fixed');
// ... logic but with bug fixed ...
this.callSuper();
}
});
The patch method cannot use callParent to call the superclass method since
that would call the overridden method containing the bug. In other words, the
above patch would only produce "Fixed" then "Good" in the console log, whereas,
using callParent would produce "Fixed" then "Bad" then "Good".
Available since: Ext JS 4.1.3
Parameters
- args : Array/Arguments
The arguments, either an array or the arguments object
from the current method, for example: this.callSuper(arguments)
Returns
- Object
Returns the result of calling the superclass method
cleanParams( p )Removes filter related query parameters from the provided object. ...Removes filter related query parameters from the provided object.
Available since: 4.0.7
Parameters
- p : Object
Query parameters that may contain filter related fields.
clearFilters( )Turns all filters off. ...Turns all filters off. This does not clear the configuration information
(see removeAll).
Available since: 4.0.7
Removes all listeners for this object including the managed listeners ...Removes all listeners for this object including the managed listeners
Available since: 4.0.0
Removes all managed listeners for this object. ...Removes all managed listeners for this object.
Available since: 4.0.0
continueFireEvent( eventName, args, bubbles )private createFilters( )privateCreate the Filter objects for the current configuration, destroying any existing ones first. ...Create the Filter objects for the current configuration, destroying any existing ones first.
Available since: 4.0.7
Creates an event handling function which refires the event from this object as the passed event name. ... enableBubble( eventNames )Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. ...Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. There is no implementation in the Observable base class.
This is commonly used by Ext.Components to bubble events to owner Containers.
See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the
Component's immediate owner. But if a known target is required, this can be overridden to access the
required target more quickly.
Example:
Ext.define('Ext.overrides.form.field.Base', {
override: 'Ext.form.field.Base',
// Add functionality to Field's initComponent to enable the change event to bubble
initComponent: function () {
this.callParent();
this.enableBubble('change');
}
});
var myForm = Ext.create('Ext.form.Panel', {
title: 'User Details',
items: [{
...
}],
listeners: {
change: function() {
// Title goes red if form has been modified.
myForm.header.setStyle('color', 'red');
}
}
});
Available since: 3.4.0
Parameters
Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addList...Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addListener).
An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by
calling enableBubble.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to fire.
- args : Object...
Variable number of parameters are passed to handlers.
Returns
- Boolean
returns false if any of the handlers return false otherwise it returns true.
getAdditionalData( data, idx, record, orig )templateProvide additional data to the prepareData call within the grid view. ...Provide additional data to the prepareData call within the grid view.
Available since: 4.0.0
This is a template method.
a hook into the functionality of this class.
Feel free to override it in child classes.
Parameters
- data : Object
The data for this particular record.
- idx : Number
The row index for this record.
- record : Ext.data.Model
The record instance
- orig : Object
The original result from the prepareData call to massage.
Overrides: Ext.grid.feature.Grouping.getAdditionalData
getBubbleParent( ) : Ext.util.ObservableprivateGets the bubbling parent for an Observable ...Gets the bubbling parent for an Observable
Available since: 4.0.7
Returns
- Ext.util.Observable
The bubble parent. null is returned if no bubble target exists
getFeatureTpl( )private ...
Available since: 4.0.0
Overrides: Ext.grid.feature.Grouping.getFeatureTpl
Returns a filter for the given dataIndex, if one exists. ...Returns a filter for the given dataIndex, if one exists.
Available since: 4.0.7
Parameters
- dataIndex : String
The dataIndex of the desired filter object.
Returns
Function for locating filter classes, overwrite this with your favorite
loader to provide dynamic filter loading. ...Function for locating filter classes, overwrite this with your favorite
loader to provide dynamic filter loading.
Available since: 4.0.7
Parameters
- type : String
The type of filter to load ('Filter' is automatically
appended to the passed type; eg, 'string' becomes 'StringFilter').
Returns
- Function
The Ext.ux.grid.filter.Class
getFilterData( ) : ArrayReturns an Array of the currently active filters. ...Returns an Array of the currently active filters.
Available since: 4.0.7
Returns
- Array
filters Array of the currently active filters.
getFireEventArgs( eventName, view, featureTarget, e )templateAbstract method to be overriden when a feature should add additional
arguments to its event signature. ...Abstract method to be overriden when a feature should add additional
arguments to its event signature. By default the event will fire:
- view - The underlying Ext.view.Table
- featureTarget - The matched element by the defined eventSelector
The method must also return the eventName as the first index of the array
to be passed to fireEvent.
Available since: 4.0.0
This is a template method.
a hook into the functionality of this class.
Feel free to override it in child classes.
Parameters
Overrides: Ext.grid.feature.Grouping.getFireEventArgs
getFragmentTpl( )private ...
Available since: 4.0.0
Overrides: Ext.grid.feature.Grouping.getFragmentTpl
getMenuFilter( )privateGet the filter menu from the filters MixedCollection based on the clicked header ...Get the filter menu from the filters MixedCollection based on the clicked header
Available since: 4.0.7
getMetaRowTplFragments( )templateAllows a feature to inject member methods into the metaRowTpl. ...Allows a feature to inject member methods into the metaRowTpl. This is
important for embedding functionality which will become part of the proper
row tpl.
Available since: 4.0.0
This is a template method.
a hook into the functionality of this class.
Feel free to override it in child classes.
getRecordFilter( )privateMethod factory that generates a record validator for the filters active at the time
of invokation. ...Method factory that generates a record validator for the filters active at the time
of invokation.
Available since: 4.0.7
Checks to see if this object has any listeners for a specified event, or whether the event bubbles. ...Checks to see if this object has any listeners for a specified event, or whether the event bubbles. The answer
indicates whether the event needs firing or not.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to check for
Returns
- Boolean
true if the event is being listened for or bubbles, else false
Initialize configuration for this class. ...Initialize configuration for this class. a typical example:
Ext.define('My.awesome.Class', {
// The default config
config: {
name: 'Awesome',
isAwesome: true
},
constructor: function(config) {
this.initConfig(config);
}
});
var awesome = new My.awesome.Class({
name: 'Super Awesome'
});
alert(awesome.getName()); // 'Super Awesome'
Available since: 4.0.0
Parameters
- config : Object
Returns
- Ext.Base
this
Shorthand for addManagedListener. ...Shorthand for addManagedListener.
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is
destroyed.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
- options : Object (optional)
If the ename parameter was an event name, this is the
addListener options.
Returns
- Object
Only when the destroyable option is specified.
A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:
this.btnListeners = = myButton.mon({
destroyable: true
mouseover: function() { console.log('mouseover'); },
mouseout: function() { console.log('mouseout'); },
click: function() { console.log('click'); }
});
And when those listeners need to be removed:
Ext.destroy(this.btnListeners);
or
this.btnListeners.destroy();
mun( item, ename, [fn], [scope] )Shorthand for removeManagedListener. ...Shorthand for removeManagedListener.
Removes listeners that were added by the mon method.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
mutateMetaRowTpl( metaRowTplArray )templateAllows a feature to mutate the metaRowTpl. ...Allows a feature to mutate the metaRowTpl.
The array received as a single argument can be manipulated to add things
on the end/begining of a particular row.
Available since: 4.0.0
This is a template method.
a hook into the functionality of this class.
Feel free to override it in child classes.
Parameters
- metaRowTplArray : Array
A String array to be used constructing an XTemplate
to render the rows. This Array may be changed to provide extra DOM structure.
Overrides: Ext.grid.feature.Grouping.mutateMetaRowTpl
Shorthand for addListener. ...Shorthand for addListener.
Appends an event handler to this object. For example:
myGridPanel.on("mouseover", this.onMouseOver, this);
The method also allows for a single argument to be passed which is a config object
containing properties which specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
Names of methods in a specified scope may also be used. Note that
scope MUST be specified to use this option:
myGridPanel.on({
cellClick: {fn: 'onCellClick', scope: this, single: true},
mouseover: {fn: 'onMouseOver', scope: panel}
});
Available since: 1.1.0
Parameters
- eventName : String/Object
The name of the event to listen for.
May also be an object who's property names are event names.
- fn : Function (optional)
The method the event invokes, or if scope is specified, the name* of the method within
the specified scope. Will be called with arguments
given to fireEvent plus the options parameter described below.
- scope : Object (optional)
The scope (this reference) in which the handler function is
executed. If omitted, defaults to the object which fired the event.
- options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last
argument to every event handler.
This object may contain any of the following properties:
- scope : Object
The scope (this reference) in which the handler function is executed. If omitted,
defaults to the object which fired the event.
- delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
- single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
- buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed
by the specified number of milliseconds. If the event fires again within that time,
the original handler is not invoked, but the new handler is scheduled in its place.
- target : Ext.util.Observable
Only call the handler if the event was fired on the target Observable, not if the event
was bubbled up from a child Observable.
- element : String
This option is only valid for listeners bound to Components.
The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of
Components which will exist only after the Component is rendered.
For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({
title: 'The title',
listeners: {
click: this.handlePanelClick,
element: 'body'
}
});
- destroyable : Boolean (optional)
When specified as true, the function returns A Destroyable object. An object which implements the destroy method which removes all listeners added in this call.
Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, {
single: true,
delay: 100
});
Defaults to: false
Returns
- Object
Only when the destroyable option is specified.
A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:
this.btnListeners = = myButton.on({
destroyable: true
mouseover: function() { console.log('mouseover'); },
mouseout: function() { console.log('mouseout'); },
click: function() { console.log('click'); }
});
And when those listeners need to be removed:
Ext.destroy(this.btnListeners);
or
this.btnListeners.destroy();
onBeforeCheck( check, value )private onBeforeLoad( store, options )private onCheckChange( item, value )private onConfigUpdate( names, callback, scope )private onLoad( store )privateHandler for store's load event when configured for local filtering ...Handler for store's load event when configured for local filtering
Available since: 4.0.7
Parameters
- store : Object
onMenuBeforeShow( menu )privateHandle showing of the grid's header menu. ...Handle showing of the grid's header menu. Sets up the filter item and menu
appropriate for the target column.
Available since: 4.0.7
Parameters
- menu : Object
onMenuCreate( headerCt, menu )private onRefresh( )privateHandler called when the grid's view is refreshed ...Handler called when the grid's view is refreshed
Available since: 4.0.7
onStateChange( event, filter )private prepareClass( T )privatePrepares a given class for observable instances. ...Prepares a given class for observable instances. This method is called when a
class derives from this class or uses this class as a mixin.
Available since: 4.1.0
Parameters
- T : Function
The class constructor to prepare.
Relays selected events from the specified Observable as if the events were fired by this. ...Relays selected events from the specified Observable as if the events were fired by this.
For example if you are extending Grid, you might decide to forward some events from store.
So you can do this inside your initComponent:
this.relayEvents(this.getStore(), ['load']);
The grid instance will then have an observable 'load' event which will be passed the
parameters of the store's load event and any function fired with the grid's load event
would have access to the grid using the this keyword.
Available since: 2.3.0
Parameters
- origin : Object
The Observable whose events this object is to relay.
- events : String[]
Array of event names to relay.
- prefix : String (optional)
A common prefix to prepend to the event names. For example:
this.relayEvents(this.getStore(), ['load', 'clear'], 'store');
Now the grid will forward 'load' and 'clear' events of store as 'storeload' and 'storeclear'.
Returns
- Object
A Destroyable object. An object which implements the destroy method which, when destroyed, removes all relayers. For example:
this.storeRelayers = this.relayEvents(this.getStore(), ['load', 'clear'], 'store');
Can be undone by calling
Ext.destroy(this.storeRelayers);
or
this.store.relayers.destroy();
removeAll( )Remove all filters, permanently destroying them. ...Remove all filters, permanently destroying them.
Available since: 4.0.7
removeListener( eventName, fn, [scope] )Removes an event handler. ...Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the
addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the
scope argument specified in the original call to addListener or the listener will not be removed.
removeManagedListener( item, ename, [fn], [scope] )Removes listeners that were added by the mon method. ...Removes listeners that were added by the mon method.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the ename parameter was an event name, this is the handler function.
- scope : Object (optional)
If the ename parameter was an event name, this is the scope (this reference)
in which the handler function is executed.
removeManagedListenerItem( isClear, managedListener )private resumeEvents( )Resumes firing events (see suspendEvents). ...Resumes firing events (see suspendEvents).
If events were suspended using the queueSuspended parameter, then all events fired
during event suspension will be sent to any listeners now.
Available since: 2.3.0
Get the reference to the class from which this object was instantiated. ...Get the reference to the class from which this object was instantiated. Note that unlike self,
this.statics() is scope-independent and it always returns the class from which it was called, regardless of what
this points to during run-time
Ext.define('My.Cat', {
statics: {
totalCreated: 0,
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
var statics = this.statics();
alert(statics.speciesName); // always equals to 'Cat' no matter what 'this' refers to
// equivalent to: My.Cat.speciesName
alert(this.self.speciesName); // dependent on 'this'
statics.totalCreated++;
},
clone: function() {
var cloned = new this.self; // dependent on 'this'
cloned.groupName = this.statics().speciesName; // equivalent to: My.Cat.speciesName
return cloned;
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
},
constructor: function() {
this.callParent();
}
});
var cat = new My.Cat(); // alerts 'Cat', then alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
alert(clone.groupName); // alerts 'Cat'
alert(My.Cat.totalCreated); // alerts 3
Available since: 4.0.0
Returns
suspendEvents( queueSuspended )Suspends the firing of all events. ...Suspends the firing of all events. (see resumeEvents)
Available since: 2.3.0
Parameters
- queueSuspended : Boolean
Pass as true to queue up suspended events to be fired
after the resumeEvents call instead of discarding all suspended events.
un( eventName, fn, [scope] )Shorthand for removeListener. ...Shorthand for removeListener.
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the
addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the
scope argument specified in the original call to addListener or the listener will not be removed.
Available since: 4.0.7
Parameters
- config : Object
Returns
Overrides: Ext.grid.feature.Feature.constructor
Adds the specified events to the list of events which this Observable may fire.
Available since: 1.1.0
Parameters
Adds a filter to the collection and observes it for state change.
Available since: 4.0.7
Parameters
- config : Object/Ext.ux.grid.filter.Filter
A filter configuration or a filter object.
Returns
- Ext.ux.grid.filter.Filter
The existing or newly created filter object.
Adds filters to the collection.
Available since: 4.0.7
Parameters
- filters : Array
An Array of filter configuration objects.
Appends an event handler to this object. For example:
myGridPanel.on("mouseover", this.onMouseOver, this);
The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
Names of methods in a specified scope may also be used. Note that
scope MUST be specified to use this option:
myGridPanel.on({
cellClick: {fn: 'onCellClick', scope: this, single: true},
mouseover: {fn: 'onMouseOver', scope: panel}
});
Available since: 1.1.0
Parameters
- eventName : String/Object
The name of the event to listen for. May also be an object who's property names are event names.
- fn : Function (optional)
The method the event invokes, or if
scopeis specified, the name* of the method within the specifiedscope. Will be called with arguments given to fireEvent plus theoptionsparameter described below. - scope : Object (optional)
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.
This object may contain any of the following properties:
- scope : Object
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
- single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
- buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
- target : Ext.util.Observable
Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.
- element : String
This option is only valid for listeners bound to Components. The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of Components which will exist only after the Component is rendered. For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({ title: 'The title', listeners: { click: this.handlePanelClick, element: 'body' } }); - destroyable : Boolean (optional)
When specified as
true, the function returns ADestroyableobject. An object which implements thedestroymethod which removes all listeners added in this call.Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, { single: true, delay: 100 });Defaults to:
false
- scope : Object
Returns
- Object
Only when the
destroyableoption is specified.A
Destroyableobject. An object which implements thedestroymethod which removes all listeners added in this call. For example:this.btnListeners = = myButton.on({ destroyable: true mouseover: function() { console.log('mouseover'); }, mouseout: function() { console.log('mouseout'); }, click: function() { console.log('click'); } });And when those listeners need to be removed:
Ext.destroy(this.btnListeners);or
this.btnListeners.destroy();
Overrides: Ext.AbstractComponent.addListener
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destroyed.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed. - options : Object (optional)
If the
enameparameter was an event name, this is the addListener options.
Returns
- Object
Only when the
destroyableoption is specified.A
Destroyableobject. An object which implements thedestroymethod which removes all listeners added in this call. For example:this.btnListeners = = myButton.mon({ destroyable: true mouseover: function() { console.log('mouseover'); }, mouseout: function() { console.log('mouseout'); }, click: function() { console.log('click'); } });And when those listeners need to be removed:
Ext.destroy(this.btnListeners);or
this.btnListeners.destroy();
Approriate place to attach events to the view, selectionmodel, headerCt, etc
Available since: 4.0.7
This is a template method. a hook into the functionality of this class. Feel free to override it in child classes.
Overrides: Ext.grid.feature.Feature.attachEvents
Changes the data store bound to this view and refreshes it.
Available since: 4.0.7
Parameters
- store : Ext.data.Store
The store to bind to this view
Function to take the active filters data and build it into a query. The format of the query depends on the encode configuration:
false(Default) : Flatten into query string of the form (assumingparamPrefix='filters':filters[0][field]="someDataIndex"& filters[0][data][comparison]="someValue1"& filters[0][data][type]="someValue2"& filters[0][data][value]="someValue3"&true: JSON encode the filter data{filters:[{"field":"someDataIndex","comparison":"someValue1","type":"someValue2","value":"someValue3"}]}
Override this method to customize the format of the filter query for remote requests.
Available since: 4.0.7
Parameters
- filters : Array
A collection of objects representing active filters and their configuration. Each element will take the form of {field: dataIndex, data: filterConf}. dataIndex is not assured to be unique as any one filter may be a composite of more basic filters for the same dataIndex.
Returns
- Object
Query keys and values
Call the original method that was previously overridden with override
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
this.callOverridden();
alert("Meeeeoooowwww");
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
This method has been deprecated
as of 4.1. Use callParent instead.
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callOverridden(arguments)
Returns
- Object
Returns the result of calling the overridden method
Call the "parent" method of the current method. That is the method previously overridden by derivation or by an override (see Ext.define).
Ext.define('My.Base', {
constructor: function (x) {
this.x = x;
},
statics: {
method: function (x) {
return x;
}
}
});
Ext.define('My.Derived', {
extend: 'My.Base',
constructor: function () {
this.callParent([21]);
}
});
var obj = new My.Derived();
alert(obj.x); // alerts 21
This can be used with an override as follows:
Ext.define('My.DerivedOverride', {
override: 'My.Derived',
constructor: function (x) {
this.callParent([x*2]); // calls original My.Derived constructor
}
});
var obj = new My.Derived();
alert(obj.x); // now alerts 42
This also works with static methods.
Ext.define('My.Derived2', {
extend: 'My.Base',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Base.method
}
}
});
alert(My.Base.method(10); // alerts 10
alert(My.Derived2.method(10); // alerts 20
Lastly, it also works with overridden static methods.
Ext.define('My.Derived2Override', {
override: 'My.Derived2',
statics: {
method: function (x) {
return this.callParent([x*2]); // calls My.Derived2.method
}
}
});
alert(My.Derived2.method(10); // now alerts 40
To override a method and replace it and also call the superclass method, use callSuper. This is often done to patch a method to fix a bug.
Available since: 4.0.0
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callParent(arguments)
Returns
- Object
Returns the result of calling the parent method
This method is used by an override to call the superclass method but bypass any overridden method. This is often done to "patch" a method that contains a bug but for whatever reason cannot be fixed directly.
Consider:
Ext.define('Ext.some.Class', {
method: function () {
console.log('Good');
}
});
Ext.define('Ext.some.DerivedClass', {
method: function () {
console.log('Bad');
// ... logic but with a bug ...
this.callParent();
}
});
To patch the bug in DerivedClass.method, the typical solution is to create an
override:
Ext.define('App.paches.DerivedClass', {
override: 'Ext.some.DerivedClass',
method: function () {
console.log('Fixed');
// ... logic but with bug fixed ...
this.callSuper();
}
});
The patch method cannot use callParent to call the superclass method since
that would call the overridden method containing the bug. In other words, the
above patch would only produce "Fixed" then "Good" in the console log, whereas,
using callParent would produce "Fixed" then "Bad" then "Good".
Available since: Ext JS 4.1.3
Parameters
- args : Array/Arguments
The arguments, either an array or the
argumentsobject from the current method, for example:this.callSuper(arguments)
Returns
- Object
Returns the result of calling the superclass method
Removes filter related query parameters from the provided object.
Available since: 4.0.7
Parameters
- p : Object
Query parameters that may contain filter related fields.
Turns all filters off. This does not clear the configuration information (see removeAll).
Available since: 4.0.7
Removes all listeners for this object including the managed listeners
Available since: 4.0.0
Removes all managed listeners for this object.
Available since: 4.0.0
Create the Filter objects for the current configuration, destroying any existing ones first.
Available since: 4.0.7
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if
present. There is no implementation in the Observable base class.
This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.
Example:
Ext.define('Ext.overrides.form.field.Base', {
override: 'Ext.form.field.Base',
// Add functionality to Field's initComponent to enable the change event to bubble
initComponent: function () {
this.callParent();
this.enableBubble('change');
}
});
var myForm = Ext.create('Ext.form.Panel', {
title: 'User Details',
items: [{
...
}],
listeners: {
change: function() {
// Title goes red if form has been modified.
myForm.header.setStyle('color', 'red');
}
}
});
Available since: 3.4.0
Parameters
Fires the specified event with the passed parameters (minus the event name, plus the options object passed
to addListener).
An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to fire.
- args : Object...
Variable number of parameters are passed to handlers.
Returns
- Boolean
returns false if any of the handlers return false otherwise it returns true.
Provide additional data to the prepareData call within the grid view.
Available since: 4.0.0
This is a template method. a hook into the functionality of this class. Feel free to override it in child classes.
Parameters
- data : Object
The data for this particular record.
- idx : Number
The row index for this record.
- record : Ext.data.Model
The record instance
- orig : Object
The original result from the prepareData call to massage.
Overrides: Ext.grid.feature.Grouping.getAdditionalData
Gets the bubbling parent for an Observable
Available since: 4.0.7
Returns
- Ext.util.Observable
The bubble parent. null is returned if no bubble target exists
Available since: 4.0.0
Overrides: Ext.grid.feature.Grouping.getFeatureTpl
Returns a filter for the given dataIndex, if one exists.
Available since: 4.0.7
Parameters
- dataIndex : String
The dataIndex of the desired filter object.
Returns
Function for locating filter classes, overwrite this with your favorite loader to provide dynamic filter loading.
Available since: 4.0.7
Parameters
- type : String
The type of filter to load ('Filter' is automatically appended to the passed type; eg, 'string' becomes 'StringFilter').
Returns
- Function
The Ext.ux.grid.filter.Class
Returns an Array of the currently active filters.
Available since: 4.0.7
Returns
- Array
filters Array of the currently active filters.
Abstract method to be overriden when a feature should add additional arguments to its event signature. By default the event will fire:
- view - The underlying Ext.view.Table
- featureTarget - The matched element by the defined eventSelector
The method must also return the eventName as the first index of the array to be passed to fireEvent.
Available since: 4.0.0
This is a template method. a hook into the functionality of this class. Feel free to override it in child classes.
Parameters
Overrides: Ext.grid.feature.Grouping.getFireEventArgs
Available since: 4.0.0
Overrides: Ext.grid.feature.Grouping.getFragmentTpl
Get the filter menu from the filters MixedCollection based on the clicked header
Available since: 4.0.7
Allows a feature to inject member methods into the metaRowTpl. This is important for embedding functionality which will become part of the proper row tpl.
Available since: 4.0.0
This is a template method. a hook into the functionality of this class. Feel free to override it in child classes.
Method factory that generates a record validator for the filters active at the time of invokation.
Available since: 4.0.7
Checks to see if this object has any listeners for a specified event, or whether the event bubbles. The answer indicates whether the event needs firing or not.
Available since: 1.1.0
Parameters
- eventName : String
The name of the event to check for
Returns
- Boolean
trueif the event is being listened for or bubbles, elsefalse
Initialize configuration for this class. a typical example:
Ext.define('My.awesome.Class', {
// The default config
config: {
name: 'Awesome',
isAwesome: true
},
constructor: function(config) {
this.initConfig(config);
}
});
var awesome = new My.awesome.Class({
name: 'Super Awesome'
});
alert(awesome.getName()); // 'Super Awesome'
Available since: 4.0.0
Parameters
- config : Object
Returns
- Ext.Base
this
Shorthand for addManagedListener.
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destroyed.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item to which to add a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed. - options : Object (optional)
If the
enameparameter was an event name, this is the addListener options.
Returns
- Object
Only when the
destroyableoption is specified.A
Destroyableobject. An object which implements thedestroymethod which removes all listeners added in this call. For example:this.btnListeners = = myButton.mon({ destroyable: true mouseover: function() { console.log('mouseover'); }, mouseout: function() { console.log('mouseout'); }, click: function() { console.log('click'); } });And when those listeners need to be removed:
Ext.destroy(this.btnListeners);or
this.btnListeners.destroy();
Shorthand for removeManagedListener.
Removes listeners that were added by the mon method.
Available since: 4.0.2
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed.
Allows a feature to mutate the metaRowTpl. The array received as a single argument can be manipulated to add things on the end/begining of a particular row.
Available since: 4.0.0
This is a template method. a hook into the functionality of this class. Feel free to override it in child classes.
Parameters
- metaRowTplArray : Array
A String array to be used constructing an XTemplate to render the rows. This Array may be changed to provide extra DOM structure.
Overrides: Ext.grid.feature.Grouping.mutateMetaRowTpl
Shorthand for addListener.
Appends an event handler to this object. For example:
myGridPanel.on("mouseover", this.onMouseOver, this);
The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:
myGridPanel.on({
cellClick: this.onCellClick,
mouseover: this.onMouseOver,
mouseout: this.onMouseOut,
scope: this // Important. Ensure "this" is correct during handler execution
});
One can also specify options for each event handler separately:
myGridPanel.on({
cellClick: {fn: this.onCellClick, scope: this, single: true},
mouseover: {fn: panel.onMouseOver, scope: panel}
});
Names of methods in a specified scope may also be used. Note that
scope MUST be specified to use this option:
myGridPanel.on({
cellClick: {fn: 'onCellClick', scope: this, single: true},
mouseover: {fn: 'onMouseOver', scope: panel}
});
Available since: 1.1.0
Parameters
- eventName : String/Object
The name of the event to listen for. May also be an object who's property names are event names.
- fn : Function (optional)
The method the event invokes, or if
scopeis specified, the name* of the method within the specifiedscope. Will be called with arguments given to fireEvent plus theoptionsparameter described below. - scope : Object (optional)
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - options : Object (optional)
An object containing handler configuration.
Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.
This object may contain any of the following properties:
- scope : Object
The scope (
thisreference) in which the handler function is executed. If omitted, defaults to the object which fired the event. - delay : Number
The number of milliseconds to delay the invocation of the handler after the event fires.
- single : Boolean
True to add a handler to handle just the next firing of the event, and then remove itself.
- buffer : Number
Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
- target : Ext.util.Observable
Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.
- element : String
This option is only valid for listeners bound to Components. The name of a Component property which references an element to add a listener to.
This option is useful during Component construction to add DOM event listeners to elements of Components which will exist only after the Component is rendered. For example, to add a click listener to a Panel's body:
new Ext.panel.Panel({ title: 'The title', listeners: { click: this.handlePanelClick, element: 'body' } }); - destroyable : Boolean (optional)
When specified as
true, the function returns ADestroyableobject. An object which implements thedestroymethod which removes all listeners added in this call.Combining Options
Using the options argument, it is possible to combine different types of listeners:
A delayed, one-time listener.
myPanel.on('hide', this.handleClick, this, { single: true, delay: 100 });Defaults to:
false
- scope : Object
Returns
- Object
Only when the
destroyableoption is specified.A
Destroyableobject. An object which implements thedestroymethod which removes all listeners added in this call. For example:this.btnListeners = = myButton.on({ destroyable: true mouseover: function() { console.log('mouseover'); }, mouseout: function() { console.log('mouseout'); }, click: function() { console.log('click'); } });And when those listeners need to be removed:
Ext.destroy(this.btnListeners);or
this.btnListeners.destroy();
Handler for store's load event when configured for local filtering
Available since: 4.0.7
Parameters
- store : Object
Handle showing of the grid's header menu. Sets up the filter item and menu appropriate for the target column.
Available since: 4.0.7
Parameters
- menu : Object
Handler called when the grid's view is refreshed
Available since: 4.0.7
Prepares a given class for observable instances. This method is called when a class derives from this class or uses this class as a mixin.
Available since: 4.1.0
Parameters
- T : Function
The class constructor to prepare.
Relays selected events from the specified Observable as if the events were fired by this.
For example if you are extending Grid, you might decide to forward some events from store. So you can do this inside your initComponent:
this.relayEvents(this.getStore(), ['load']);
The grid instance will then have an observable 'load' event which will be passed the
parameters of the store's load event and any function fired with the grid's load event
would have access to the grid using the this keyword.
Available since: 2.3.0
Parameters
- origin : Object
The Observable whose events this object is to relay.
- events : String[]
Array of event names to relay.
- prefix : String (optional)
A common prefix to prepend to the event names. For example:
this.relayEvents(this.getStore(), ['load', 'clear'], 'store');Now the grid will forward 'load' and 'clear' events of store as 'storeload' and 'storeclear'.
Returns
- Object
A
Destroyableobject. An object which implements thedestroymethod which, when destroyed, removes all relayers. For example:this.storeRelayers = this.relayEvents(this.getStore(), ['load', 'clear'], 'store');Can be undone by calling
Ext.destroy(this.storeRelayers);or
this.store.relayers.destroy();
Remove all filters, permanently destroying them.
Available since: 4.0.7
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.
Removes listeners that were added by the mon method.
Available since: 4.0.0
Parameters
- item : Ext.util.Observable/Ext.Element
The item from which to remove a listener/listeners.
- ename : Object/String
The event name, or an object containing event name properties.
- fn : Function (optional)
If the
enameparameter was an event name, this is the handler function. - scope : Object (optional)
If the
enameparameter was an event name, this is the scope (thisreference) in which the handler function is executed.
Resumes firing events (see suspendEvents).
If events were suspended using the queueSuspended parameter, then all events fired
during event suspension will be sent to any listeners now.
Available since: 2.3.0
Get the reference to the class from which this object was instantiated. Note that unlike self,
this.statics() is scope-independent and it always returns the class from which it was called, regardless of what
this points to during run-time
Ext.define('My.Cat', {
statics: {
totalCreated: 0,
speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
},
constructor: function() {
var statics = this.statics();
alert(statics.speciesName); // always equals to 'Cat' no matter what 'this' refers to
// equivalent to: My.Cat.speciesName
alert(this.self.speciesName); // dependent on 'this'
statics.totalCreated++;
},
clone: function() {
var cloned = new this.self; // dependent on 'this'
cloned.groupName = this.statics().speciesName; // equivalent to: My.Cat.speciesName
return cloned;
}
});
Ext.define('My.SnowLeopard', {
extend: 'My.Cat',
statics: {
speciesName: 'Snow Leopard' // My.SnowLeopard.speciesName = 'Snow Leopard'
},
constructor: function() {
this.callParent();
}
});
var cat = new My.Cat(); // alerts 'Cat', then alerts 'Cat'
var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'
var clone = snowLeopard.clone();
alert(Ext.getClassName(clone)); // alerts 'My.SnowLeopard'
alert(clone.groupName); // alerts 'Cat'
alert(My.Cat.totalCreated); // alerts 3
Available since: 4.0.0
Returns
Suspends the firing of all events. (see resumeEvents)
Available since: 2.3.0
Parameters
- queueSuspended : Boolean
Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events.
Shorthand for removeListener.
Removes an event handler.
Available since: 1.1.0
Parameters
- eventName : String
The type of event the handler was associated with.
- fn : Function
The handler to remove. This must be a reference to the function passed into the addListener call.
- scope : Object (optional)
The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.
Static Methods addMember( name, member )chainableprivatestatic addMembers( members )chainablestaticAdd methods / properties to the prototype of this class. ...Add methods / properties to the prototype of this class.
Ext.define('My.awesome.Cat', {
constructor: function() {
...
}
});
My.awesome.Cat.addMembers({
meow: function() {
alert('Meowww...');
}
});
var kitty = new My.awesome.Cat;
kitty.meow();
Available since: 4.1.0
Parameters
- members : Object
Add / override static properties of this class. ...Add / override static properties of this class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.addStatics({
someProperty: 'someValue', // My.cool.Class.someProperty = 'someValue'
method1: function() { ... }, // My.cool.Class.method1 = function() { ... };
method2: function() { ... } // My.cool.Class.method2 = function() { ... };
});
Available since: 4.0.2
Parameters
- members : Object
Returns
- Ext.Base
this
Borrow another class' members to the prototype of this class. ...Borrow another class' members to the prototype of this class.
Ext.define('Bank', {
money: '$$$',
printMoney: function() {
alert('$$$$$$$');
}
});
Ext.define('Thief', {
...
});
Thief.borrow(Bank, ['money', 'printMoney']);
var steve = new Thief();
alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'
Available since: 4.0.2
Parameters
- fromClass : Ext.Base
The class to borrow members from
- members : Array/String
The names of the members to borrow
Returns
- Ext.Base
this
Create a new instance of this Class. ...Create a new instance of this Class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.create({
someConfig: true
});
All parameters are passed to the constructor of the class.
Available since: 4.0.2
Returns
- Object
the created instance.
createAlias( alias, origin )staticCreate aliases for existing prototype methods. ...Create aliases for existing prototype methods. Example:
Ext.define('My.cool.Class', {
method1: function() { ... },
method2: function() { ... }
});
var test = new My.cool.Class();
My.cool.Class.createAlias({
method3: 'method1',
method4: 'method2'
});
test.method3(); // test.method1()
My.cool.Class.createAlias('method5', 'method3');
test.method5(); // test.method3() -> test.method1()
Available since: 4.0.2
Parameters
- alias : String/Object
The new method name, or an object to set multiple aliases. See
flexSetter
- origin : String/Object
The original method name
Get the current class' name in string format. ...Get the current class' name in string format.
Ext.define('My.cool.Class', {
constructor: function() {
alert(this.self.getName()); // alerts 'My.cool.Class'
}
});
My.cool.Class.getName(); // 'My.cool.Class'
Available since: 4.0.4
Returns
- String
className
implement( )deprecatedstaticAdds members to class. ...Adds members to class.
This method has been deprecated since 4.1
Use addMembers instead.
Available since: 4.0.2
mixin( name, mixinClass )chainableprivatestatic onExtended( fn, scope )chainableprivatestatic Override members of this class. ...Override members of this class. Overridden methods can be invoked via
callParent.
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
this.callParent(arguments);
alert("Meeeeoooowwww");
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
As of 4.1, direct use of this method is deprecated. Use Ext.define
instead:
Ext.define('My.CatOverride', {
override: 'My.Cat',
constructor: function() {
alert("I'm going to be a cat!");
this.callParent(arguments);
alert("Meeeeoooowwww");
}
});
The above accomplishes the same result but can be managed by the Ext.Loader
which can properly order the override and its target class and the build process
can determine whether the override is needed based on the required state of the
target class (My.Cat).
This method has been deprecated since 4.1.0
Use Ext.define instead
Available since: 4.0.2
Parameters
- members : Object
The properties to add to this class. This should be
specified as an object literal containing one or more properties.
Returns
- Ext.Base
this class
Add methods / properties to the prototype of this class.
Ext.define('My.awesome.Cat', {
constructor: function() {
...
}
});
My.awesome.Cat.addMembers({
meow: function() {
alert('Meowww...');
}
});
var kitty = new My.awesome.Cat;
kitty.meow();
Available since: 4.1.0
Parameters
- members : Object
Add / override static properties of this class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.addStatics({
someProperty: 'someValue', // My.cool.Class.someProperty = 'someValue'
method1: function() { ... }, // My.cool.Class.method1 = function() { ... };
method2: function() { ... } // My.cool.Class.method2 = function() { ... };
});
Available since: 4.0.2
Parameters
- members : Object
Returns
- Ext.Base
this
Borrow another class' members to the prototype of this class.
Ext.define('Bank', {
money: '$$$',
printMoney: function() {
alert('$$$$$$$');
}
});
Ext.define('Thief', {
...
});
Thief.borrow(Bank, ['money', 'printMoney']);
var steve = new Thief();
alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'
Available since: 4.0.2
Parameters
- fromClass : Ext.Base
The class to borrow members from
- members : Array/String
The names of the members to borrow
Returns
- Ext.Base
this
Create a new instance of this Class.
Ext.define('My.cool.Class', {
...
});
My.cool.Class.create({
someConfig: true
});
All parameters are passed to the constructor of the class.
Available since: 4.0.2
Returns
- Object
the created instance.
Create aliases for existing prototype methods. Example:
Ext.define('My.cool.Class', {
method1: function() { ... },
method2: function() { ... }
});
var test = new My.cool.Class();
My.cool.Class.createAlias({
method3: 'method1',
method4: 'method2'
});
test.method3(); // test.method1()
My.cool.Class.createAlias('method5', 'method3');
test.method5(); // test.method3() -> test.method1()
Available since: 4.0.2
Parameters
- alias : String/Object
The new method name, or an object to set multiple aliases. See flexSetter
- origin : String/Object
The original method name
Get the current class' name in string format.
Ext.define('My.cool.Class', {
constructor: function() {
alert(this.self.getName()); // alerts 'My.cool.Class'
}
});
My.cool.Class.getName(); // 'My.cool.Class'
Available since: 4.0.4
Returns
- String
className
Adds members to class.
This method has been deprecated since 4.1
Use addMembers instead.
Available since: 4.0.2
Override members of this class. Overridden methods can be invoked via callParent.
Ext.define('My.Cat', {
constructor: function() {
alert("I'm a cat!");
}
});
My.Cat.override({
constructor: function() {
alert("I'm going to be a cat!");
this.callParent(arguments);
alert("Meeeeoooowwww");
}
});
var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
// alerts "I'm a cat!"
// alerts "Meeeeoooowwww"
As of 4.1, direct use of this method is deprecated. Use Ext.define instead:
Ext.define('My.CatOverride', {
override: 'My.Cat',
constructor: function() {
alert("I'm going to be a cat!");
this.callParent(arguments);
alert("Meeeeoooowwww");
}
});
The above accomplishes the same result but can be managed by the Ext.Loader which can properly order the override and its target class and the build process can determine whether the override is needed based on the required state of the target class (My.Cat).
This method has been deprecated since 4.1.0
Use Ext.define instead
Available since: 4.0.2
Parameters
- members : Object
The properties to add to this class. This should be specified as an object literal containing one or more properties.
Returns
- Ext.Base
this class